/*-
 * SPDX-License-Identifier: BSD-3-Clause
 *
 * Copyright (c) 2018 Rafal Kozik <rafkozik@gmail.com>
 * All rights reserved.
 *
 * STM32F0x1 registers.
 */

.thumb_func
.syntax unified
.cpu cortex-m0

/* ADDRESSES */
.set SRAM,              (0x20000000)
.set SRAM_SIZE,         (0x2000)
.set PERIPHERALS,       (0x40000000)
.set AHB1,              (PERIPHERALS + 0x00020000)
.set AHB2,              (PERIPHERALS + 0x08000000)

/* Reset and clock control */
.set RCC,               (AHB1 + 0x1000)

.set RCC_AHBENR,        (0x14)

.set RCC_AHBENR_IOPAEN, (1 << 17)
.set RCC_AHBENR_IOPBEN, (1 << 18)
.set RCC_AHBENR_IOPCEN, (1 << 19)
.set RCC_AHBENR_IOPDEN, (1 << 20)
.set RCC_AHBENR_IOPEEN, (1 << 21)
.set RCC_AHBENR_IOPFEN, (1 << 22)

/* GPIO */
.set GPIOx_MODER,       (0x00)
.set GPIOx_OTYPER,      (0x04)
.set GPIOx_OSPEEDR,     (0x08)
.set GPIOx_PUPDR,       (0x0C)
.set GPIOx_IDR,         (0x10)
.set GPIOx_ODR,         (0x14)
.set GPIOx_BSRR,        (0x18)
.set GPIOx_LCKR,        (0x1C)
.set GPIOx_AFRL,        (0x20)
.set GPIOx_AFRH,        (0x24)
.set GPIOx_BRR,         (0x28)

.set GPIOA,             (AHB2 + 0x0000)
.set GPIOB,             (AHB2 + 0x0400)
.set GPIOC,             (AHB2 + 0x0800)
.set GPIOD,             (AHB2 + 0x0C00)
.set GPIOE,             (AHB2 + 0x1000)
.set GPIOF,             (AHB2 + 0x1400)
